*ASM     XOPTS(CICS,SP)                                                         
DFHEISTG DSECT                                                                  
TRTAB    DS    CL256                                                            
TAGSVR14 DS    F                       Save R14 for HTMLTAG routine             
VALSVR14 DS    F                       Save R14 for VALUE routine               
         COPY DFHWBUCD                                                          
         COPY DFHWBCDD                                                          
         DFHREGS                                                                
DFH$C930 CSECT                                                                  
DFH$C930 RMODE ANY                                                              
DFH$C930 AMODE 31                                                               
*                                                                               
         DFHEIENT DATAREG=R13,CODEREG=R12,EIBREG=R11                            
*                                                                               
*  If there is no commarea, just return.                                        
*                                                                               
         OC    EIBCALEN,EIBCALEN                                                
         BZ    RETURN                  Return if zero                           
*                                                                               
*  Address the parameter list                                                   
*                                                                               
         L     R10,DFHEICAP            Address the commarea                     
         USING COMM_PARMLIST,R10       Establish commarea addressing            
         LH    R0,CONVERTER_FUNCTION   Load the function                        
         CH    R0,=Y(URP_ENCODE)       Is it ENCODE?                            
         BE    ENCODE                  Yes                                      
         CH    R0,=Y(URP_DECODE)       Is it DECODE?                            
         BE    DECODE                  Yes                                      
*                                                                               
DECODE   DS    0H                                                               
*                                                                               
* DECODE processing will be to translate the value for DFH_STATE_TOKEN          
* from 930 back to what it was originally.                                      
*                                                                               
* If this is not a POST request or there is no user data then there             
* is nothing to do.                                                             
*                                                                               
         L     R1,DECODE_METHOD_PTR    Get HTTP method                          
         CLC   0(4,R1),=C'POST'        POST request?                            
         BNE   RETURNOK                ..No, just return                        
         L     R1,DECODE_USER_DATA_PTR Get user data                            
         LR    R8,R1                                                            
         AH    R8,DECODE_USER_DATA_LENGTH   Get end of data                     
         XC    TRTAB,TRTAB                                                      
         MVI   TRTAB+C'D',C'D'         Search for 'D'                           
         B     STARTLP                                                          
*                                                                               
TRTLP    DS    0H                                                               
         BCTR  R4,0                    Decrement for use as length              
         EX    R4,SEARCH               Use TRT to find 'D'                      
         LTR   R2,R2                                                            
         BZ    NOMATCH                 No 'D' found.  Keep searching.           
         C     R4,=F'23'               Room for state token?                    
         BL    RETURNOK                ..No, stop searching                     
         CLC   0(L'DFHSTATE,R1),DFHSTATE    State token found?                  
         BE    ENDLP                        ..Yes, process it                   
         LA    R1,1(R1)                     ..No, keep searching                
         B     STARTLP                                                          
NOMATCH  DS    0H                                                               
         LA    R4,1(R4)                Get length searched                      
         AR    R1,R4                   Update Position                          
STARTLP  DS    0H                                                               
         SR    R2,R2                   Clear R2 for TRT                         
         LR    R4,R8                                                            
         SR    R4,R1                   Get length of data remaining             
         C     R4,=F'0'                End of data?                             
         BE    RETURNOK                ..Yes, exit                              
         C     R4,=F'256'              Less than 256?                           
         BNH   TRTLP                   ..Yes, use actual length left            
         LA    R4,256                  ..No, use 256                            
         B     TRTLP                                                            
ENDLP    DS    0H                                                               
         LA    R7,L'DFHSTATE(R1)       Point to token                           
         LA    R4,8                    Set length                               
         EX    R4,XLATEIN              Translate state token                    
         B     RETURNOK                                                         
*                                                                               
ENCODE   DS    0H                                                               
*                                                                               
         L     R1,ENCODE_DATA_PTR                                               
         LR    R8,R1                                                            
         A     R8,ENCODE_INPUT_DATA_LEN     R8 = end of data                    
*                                                                               
* Find end of HTTP headers and start of HTML data.                              
*                                                                               
         XC    TRTAB,TRTAB                                                      
         MVI   TRTAB+13,X'0D'          Search for Carriage Return               
         B     STARTLP1                                                         
*                                                                               
TRTLP1   DS    0H                                                               
         BCTR  R4,0                    Decrement for use as length              
         EX    R4,SEARCH               Use TRT to find CR                       
         LTR   R2,R2                                                            
         BZ    NOMATCH1                No CR found.  Keep searching.            
         CLC   0(4,R1),=X'0D250D25'    Double CRLF found?                       
         BE    ENDLP1                  ..Yes, process HTML                      
         LA    R1,1(R1)                ..No, keep searching                     
         B     STARTLP1                                                         
NOMATCH1 DS    0H                                                               
         LA    R4,1(R4)                Get length searched                      
         AR    R1,R4                   Update Position                          
STARTLP1 DS    0H                                                               
         SR    R2,R2                   Clear R2 for TRT                         
         LR    R4,R8                                                            
         SR    R4,R1                   Get length of data remaining             
         C     R4,=F'0'                End of data?                             
         BE    RETURNOK                ..Yes, exit                              
         C     R4,=F'256'              Less than 256?                           
         BNH   TRTLP1                  ..Yes, use actual length left            
         LA    R4,256                  ..No, use 256                            
         B     TRTLP1                                                           
ENDLP1   DS    0H                                                               
         LA    R1,4(R1)                Step over double CRLF                    
         LR    R7,R1                   Save point reached in R7                 
*                                                                               
* Find the start of the HTML <form> tag and translate all the data              
* up to that point to codepage 930.                                             
*                                                                               
         MVI   TRTAB+C'<',C'<'         Search for less than sign                
         MVI   TRTAB+13,X'00'          Clear previous search char               
         B     STARTLP2                                                         
*                                                                               
TRTLP2   DS    0H                                                               
         BCTR  R4,0                    Decrement for use as length              
         EX    R4,SEARCH               Use TRT to find CR                       
         LTR   R2,R2                                                            
         BZ    NOMATCH2                No CR found.  Keep searching.            
         CLC   0(5,R1),FORM            Start of <form> tag found?               
         BE    ENDLP2                  ..Yes, process HTML                      
         LA    R1,1(R1)                ..No, keep searching                     
         B     STARTLP2                                                         
NOMATCH2 DS    0H                                                               
         LA    R4,1(R4)                Get length searched                      
         AR    R1,R4                   Update Position                          
STARTLP2 DS    0H                                                               
         SR    R2,R2                   Clear R2 for TRT                         
         LR    R4,R8                                                            
         SR    R4,R1                   Get length of data remaining             
         C     R4,=F'0'                End of data?                             
         BE    RETURNOK                ..Yes, exit                              
         C     R4,=F'256'              Less than 256?                           
         BNH   TRTLP2                  ..Yes, use actual length left            
         LA    R4,256                  ..No, use 256                            
         B     TRTLP2                                                           
ENDLP2   DS    0H                                                               
*                                                                               
* Translate all the HTML from the start to the beginning of the <form>          
* tag to codepage 930.                                                          
*     R7 = start of HTML                                                        
*     R1 = start of <form> tag                                                  
*                                                                               
         B     STARTLP3                                                         
TRANLP3  DS    0H                                                               
         BCTR  R4,0                    Decrement for use as length              
         EX    R4,XLATE                Translate to 930                         
         LA    R4,1(R4)                Get number of bytes translated           
         AR    R7,R4                   Update position                          
STARTLP3 DS    0H                                                               
         LR    R4,R1                                                            
         SR    R4,R7                   Get length of data remaining             
         C     R4,=F'0'                End of data?                             
         BE    ENDLP3                  ..Yes, exit                              
         C     R4,=F'256'              Less than 256?                           
         BNH   TRANLP3                 ..Yes, use actual length left            
         LA    R4,256                  ..No, use 256                            
         B     TRANLP3                                                          
ENDLP3   DS    0H                                                               
*                                                                               
* Process all the rest of the HTML.                                             
*                                                                               
* The only data that needs to be translated to codepage 930 are the             
* HTML tags and the symbols &lt;, &gt;, and &quot;.  The HTML will be           
* searched for < which indicates the start of a tag and & which                 
* indicates the start of a symbol.  Data within SO/SI will be ignored.          
*                                                                               
         MVI   TRTAB+14,X'0E'          Add Shift Out to search                  
         MVI   TRTAB+15,X'0F'          Add Shift In to search                   
         MVI   TRTAB+C'&&',C'&&'       Add ampersand to search                  
         SR    R5,R5                   Clear INDBCS                             
         B     STARTLP4                                                         
*                                                                               
TRTLP4   DS    0H                                                               
         BCTR  R4,0                    Decrement for use as length              
         EX    R4,SEARCH               Use TRT to find CR                       
         LTR   R2,R2                                                            
         BZ    NOMATCH4                No chars found. Keep searching.          
         C     R5,=F'0'                In a DBCS string?                        
         BE    NODBCS                  ..No, check for other chars              
         CLC   0(1,R1),=X'0F'          ..Yes, Have we found SI?                 
         BNE   STEPOVER                  ..No, Step over and continue           
         SR    R5,R5                     ..Yes, indicate not in DBCS            
         B     STEPOVER                                                         
NODBCS   DS    0H                                                               
         CLC   0(1,R1),=X'0E'          Have we found SO?                        
         BNE   CHECKSI                 ..No, Check for SI                       
         LA    R5,1                    ..Yes, Indicate now in DBCS              
         B     STEPOVER                                                         
CHECKSI  DS    0H                                                               
         CLC   0(1,R1),=X'0F'          Have we found SI?                        
         BE    STEPOVER                ..Yes, unexpected so just skip           
         CLC   0(1,R1),=C'&&'          Have we found ampersand?                 
         BNE   HTML                    ..No, must be an HTML tag                
         BAL   14,HTMLSYM              ..Yes, process symbol                    
         B     STARTLP4                                                         
HTML     DS    0H                                                               
         BAL   14,HTMLTAG              Not SO or SI so must be HTML tag         
         B     STARTLP4                Continue procesing                       
STEPOVER DS    0H                                                               
         LA    R1,1(R1)                Step to next character                   
         B     STARTLP4                                                         
NOMATCH4 DS    0H                                                               
         LA    R4,1(R4)                Get length searched                      
         AR    R1,R4                   Update Position                          
STARTLP4 DS    0H                                                               
         SR    R2,R2                   Clear R2 for TRT                         
         LR    R4,R8                                                            
         SR    R4,R1                   Get length of data remaining             
         C     R4,=F'0'                End of data?                             
         BE    RETURNOK                ..Yes, exit                              
         C     R4,=F'256'              Less than 256?                           
         BNH   TRTLP4                  ..Yes, use actual length left            
         LA    R4,256                  ..No, use 256                            
         B     TRTLP4                                                           
*                                                                               
RETURNOK DS    0H                                                               
*                                                                               
         MVC   CONVERTER_RESPONSE,=A(URP_OK)                                    
*                                                                               
RETURN   DS    0H                                                               
*                                                                               
         EXEC CICS RETURN                                                       
*                                                                               
* HTMLTAG - This routine processes a single HTML tag translating                
*           all the non-user data to codepage 930.                              
*           User data is deemed to be everything between the                    
*           double quotes of the value part of an input field.                  
*                                                                               
*           On exit R1 will point past the end of the data translated.          
*                                                                               
HTMLTAG  DS    0H                                                               
         ST    R14,TAGSVR14            Save return address                      
         LA    R1,1(R1)                Step over <                              
         LR    R7,R1                   Save start position                      
         CLC   0(2,R1),=C'in'          Is this an input field?                  
         BNE   NONINPUT                ..No, process it                         
         LA    R9,STTOKENL(R1)                                                  
         CR    R9,R8                   Room for state token?                    
         BNL   INPUT                   ..No, process normal input               
         CLC   0(STTOKENL,R1),STTOKEN  ..Yes, check for state token             
         BE    NONINPUT                Process as non input                     
*                                                                               
INPUT    DS    0H                      ..Yes, process input field               
         CR    R1,R8                   At end of data?                          
         BE    ENDLP5                  ..Yes, exit                              
FOUNDEND DS    0H                                                               
         CLC   0(1,R1),=C'>'           Found end of tag?                        
         BE    ENDLP5                  ..Yes, exit                              
         LA    R9,7(R1)                                                         
         CR    R9,R8                   Room for value=" ?                       
         BNL   TRANCHAR                ..No, translate normal char              
         CLC   0(7,R1),=C'value="'     Have we found the value?                 
         BNE   TRANCHAR                ..No, translate normal char              
         TR    0(7,R1),XLATETBL        ..Yes, Translate value="                 
         LR    R1,R9                   Skip over value="                        
         BAL   R14,VALUE               process the value                        
         B     INPUT                   Continue processing                      
TRANCHAR DS    0H                                                               
         TR    0(1,R1),XLATETBL        Translate character                      
         LA    R1,1(R1)                Get next character                       
         B     INPUT                                                            
*                                                                               
NONINPUT DS    0H                                                               
         B     STARTLP5                                                         
*                                                                               
TRTLP5   DS    0H                                                               
         BCTR  R4,0                    Decrement for use as length              
         EX    R4,SENDTAG              Use TRT to find >                        
         LTR   R2,R2                                                            
         BZ    NOMATCH5                No > found.  Keep searching.             
         LR    R4,R1                   Found end of HTML tag                    
         SR    R4,R7                                                            
         EX    R4,XLATE                                                         
         LA    R1,1(R1)                                                         
         B     ENDLP5                                                           
NOMATCH5 DS    0H                                                               
         LA    R4,1(R4)                Get length searched                      
         AR    R1,R4                   Update Position                          
STARTLP5 DS    0H                                                               
         SR    R2,R2                   Clear R2 for TRT                         
         LR    R4,R8                                                            
         SR    R4,R1                   Get length of data remaining             
         C     R4,=F'0'                End of data?                             
         BE    ENDLP5                  ..Yes, exit                              
         C     R4,=F'256'              Less than 256?                           
         BNH   TRTLP5                  ..Yes, use actual length left            
         LA    R4,256                  ..No, use 256                            
         B     TRTLP5                                                           
ENDLP5   DS    0H                                                               
         L     R14,TAGSVR14            Restore Return Address                   
         BR    R14                     Return                                   
*                                                                               
* VALUE - This routine processes the value= data on an input tag.               
*         The only data affected is &quot;, &lt;, and &gt;.  All                
*         other data remains asis.                                              
*                                                                               
VALUE    DS    0H                                                               
         ST    R14,VALSVR14            Save return address                      
         SR    R5,R5                   Clear INDBCS                             
VALLOOP  DS    0H                                                               
         C     R5,=F'0'                In DBCS?                                 
         BE    VALNDBCS                ..No, check for chars                    
         CLC   0(1,R1),=X'0F'          ..Yes, Found SI?                         
         BNE   VALSKIP                        ..No, skip char                   
         SR    R5,R5                   Indicate not in DBCS                     
VALSKIP  DS    0H                                                               
         LA    R1,1(R1)                Skip over character                      
         C     R1,R8                   At end of data?                          
         BE    VALEND                  ..Yes, return                            
         B     VALLOOP                 ..No, continue                           
VALNDBCS DS    0H                                                               
         CLC   0(1,R1),=C'"'           Found " at end of value?                 
         BE    VALEND                  ..Yes, return                            
         CLC   0(1,R1),=X'0E'          Found SO?                                
         BNE   VALAMP                  ..No, Check for ampersand                
         LA    R5,1                    Indicate in DBCS                         
         B     VALSKIP                                                          
VALAMP   DS    0H                                                               
         CLC   0(1,R1),=C'&&'          Found an ampersand?                      
         BNE   VALSKIP                 ..No, skip character                     
         BAL   R14,HTMLSYM             ..Yes, process symbol                    
         B     VALLOOP                                                          
VALEND   DS    0H                                                               
         L     R14,VALSVR14            Restore return address                   
         BR    R14                                                              
*                                                                               
* HTMLSYM - This routine translates &quot;, &lt; and &gt; to 930.               
*                                                                               
*           On entry R1 points to the &                                         
*                                                                               
*           On exit R1 will point past the ; on success or                      
*           past the & if there isn't a symbol here                             
*                                                                               
HTMLSYM  DS    0H                                                               
         LA    R1,1(R1)                Step over &                              
         LR    R7,R1                   Save start position                      
         LR    R4,R8                                                            
         SR    R4,R1                   Get length of data remaining             
         C     R4,=F'5'                Room for quot; ?                         
         BNL   CHECKQT                 ..Yes, check for quot;                   
         C     R4,=F'3'                ..No, Room for lt; or gt; ?              
         BNL   CHECKLT                       ..Yes, check for lt;               
         BR    R14                           ..No, return                       
CHECKQT  DS    0H                                                               
         CLC   0(5,R1),QUOT            Found quot; ?                            
         BNE   CHECKLT                 ..No, check for lt;                      
         LA    R4,5                    ..Yes, Set length for translate          
         EX    R4,XLATE                Translate quot;                          
         LA    R1,5(R1)                Update position                          
         BR    R14                     Return                                   
CHECKLT  DS    0H                                                               
         CLC   0(3,R1),LT              Found lt; ?                              
         BNE   CHECKGT                 ..No, check for gt;                      
         LA    R4,3                    ..Yes, Set length for translate          
         EX    R4,XLATE                Translate lt;                            
         LA    R1,3(R1)                Update position                          
         BR    R14                     Return                                   
CHECKGT  DS    0H                                                               
         CLC   0(3,R1),GT              Found gt; ?                              
         BNER  R14                     ..No, return                             
         LA    R4,3                    ..Yes, Set length for translate          
         EX    R4,XLATE                Translate gt;                            
         LA    R1,3(R1)                Update position                          
         BR    R14                     Return                                   
*                                                                               
* Static data and executed instructions                                         
*                                                                               
         DS    0F                                                               
SEARCH   TRT   0(0,R1),TRTAB      TRT will be executed                          
SENDTAG  TRT   0(0,R1),ENDTAG     TRT will be executed                          
XLATE    TR    0(0,R7),XLATETBL   TR will be executed                           
XLATEIN  TR    0(0,R7),XLATEINT   TR will be executed                           
FORM     DC    X'4C86969994'      Start of HTML <form> tag                      
QUOT     DC    X'98A496A35E'      quot;                                         
LT       DC    X'93A35E'          lt;                                           
GT       DC    X'87A35E'          gt;                                           
DFHSTATE DC    CL16'DFH_STATE_TOKEN='                                           
*                i n p u t   t y p e = " h i d d e n "                          
STTOKEN  DC    X'899597A4A340A3A897857E7F8889848485957F40'                      
*                n a m e = " D F H _ S T A T E _ T O K E N "                    
         DC    X'958194857E7FC4C6C86DE2E3C1E3C56DE3D6D2C5D57F'                  
STTOKENL EQU   *-STTOKEN                                                        
         DS    0D                                                               
XLATETBL DC    X'000102030405060708090A0B0C0D0E0F'                              
         DC    X'101112131415161718191A1B1C1D1E1F'                              
         DC    X'202122232425262728292A2B2C2D2E2F'                              
         DC    X'303132333435363738393A3B3C3D3E3F'                              
         DC    X'40574142434445464748B14B4C4D4E4F'                              
         DC    X'504951525354555658815AE05C5D5E5F'                              
         DC    X'60618283848586878889596B6C6D6E6F'                              
         DC    X'8A8C8D8E8F90919293797A7B7C7D7E7F'                              
         DC    X'6A626364656667686971949596979899'                              
         DC    X'9C727374757677788B9B9A9D9E9FA2A3'                              
         DC    X'A1A0ABB3B4B5B6B7B8B9A4A5A670A7A8'                              
         DC    X'B04A5BA9AAACADAEAFBABBBCBD80BEBF'                              
         DC    X'C0C1C2C3C4C5C6C7C8C9CACBCCCDCECF'                              
         DC    X'D0D1D2D3D4D5D6D7D8D9DADBDCDDDEDF'                              
         DC    X'B2E1E2E3E4E5E6E7E8E9EAEBECEDEEEF'                              
         DC    X'F0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFF'                              
*                                                                               
* XLATEINT reverses the translation done by XLATETBL                            
*                                                                               
XLATEINT DC    X'000102030405060708090A0B0C0D0E0F'                              
         DC    X'101112131415161718191A1B1C1D1E1F'                              
         DC    X'202122232425262728292A2B2C2D2E2F'                              
         DC    X'303132333435363738393A3B3C3D3E3F'                              
         DC    X'40424344454647484951B14B4C4D4E4F'                              
         DC    X'5052535455565741586A5AB25C5D5E5F'                              
         DC    X'60618182838485868788806B6C6D6E6F'                              
         DC    X'AD8991929394959697797A7B7C7D7E7F'                              
         DC    X'BD596263646566676869709871727374'                              
         DC    X'757677788A8B8C8D8E8F9A99919B9C9D'                              
         DC    X'A1A09E9FAAABACAEAFB3B4A2B5B6B7B8'                              
         DC    X'B04AE0A3A4A5A6A7A8A9B9BABBBCBEBF'                              
         DC    X'C0C1C2C3C4C5C6C7C8C9CACBCCCDCECF'                              
         DC    X'D0D1D2D3D4D5D6D7D8D9DADBDCDDDEDF'                              
         DC    X'5BE1E2E3E4E5E6E7E8E9EAEBECEDEEEF'                              
         DC    X'F0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFF'                              
ENDTAG   DC    256X'00'                                                         
         ORG   ENDTAG+C'>'                                                      
         DC    C'>'                                                             
         ORG   ,                                                                
         END                                                                    